#!/usr/bin/env python
#-*- coding: UTF-8 -*-
 
import wx
from wx.lib.embeddedimage import PyEmbeddedImage
from stomamisc import *

#----------------------------------------------------------------------
SmallUpArrow = PyEmbeddedImage(
    "iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAADxJ"
    "REFUOI1jZGRiZqAEMFGke2gY8P/f3/9kGwDTjM8QnAaga8JlCG3CAJdt2MQxDCAUaOjyjKMp"
    "cRAYAABS2CPsss3BWQAAAABJRU5ErkJggg==")

#----------------------------------------------------------------------
SmallDnArrow = PyEmbeddedImage(
    "iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAEhJ"
    "REFUOI1jZGRiZqAEMFGke9QABgYGBgYWdIH///7+J6SJkYmZEacLkCUJacZqAD5DsInTLhDR"
    "bcPlKrwugGnCFy6Mo3mBAQChDgRlP4RC7wAAAABJRU5ErkJggg==")
#----------------------------------------------------------------------


class VirtualListCtrl(wx.ListCtrl):
    
    def __init__(self, parent, id, config):
        if config ['ListCtrl']['grid'] == 'True':
            wx.ListCtrl.__init__(self, parent, id, style = wx.LC_REPORT | wx.LC_VIRTUAL | wx.LC_SINGLE_SEL | wx.LC_HRULES | wx.LC_VRULES)
        else:
            wx.ListCtrl.__init__(self, parent, id, style = wx.LC_REPORT | wx.LC_VIRTUAL | wx.LC_SINGLE_SEL)

        self.imagelist = wx.ImageList(16, 16, True, 3) 
        self.sm_up = self.imagelist.Add(SmallUpArrow.GetBitmap())
        self.sm_dn = self.imagelist.Add(SmallDnArrow.GetBitmap())
        self.fileidx = self.imagelist.Add(wx.ArtProvider.GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, wx.Size(16, 16)))
        #self.fileidx = self.imagelist.Add(loadIcon('audiofile.png'))
        self.SetImageList(self.imagelist, wx.IMAGE_LIST_SMALL)
                      
        self.InsertColumn(0, 'Directoryname', width = int(config ['Window']['colwidth0']))
        self.InsertColumn(1, 'Filename', width = int(config ['Window']['colwidth1']))
        self.InsertColumn(2, 'Size', format = wx.LIST_FORMAT_RIGHT, width = int(config ['Window']['colwidth2']))
        self.InsertColumn(3, 'DateTime', format = wx.LIST_FORMAT_RIGHT, width = int(config ['Window']['colwidth3']))
        self.SetColumnCount(4)
        self.datasource = []
        self.SetItemCount(0)
    #-------------------------------------------------------------------------------------------
    
    def getColumnText(self, index, col):
        item = self.GetItem(index, col)
        return item.GetText()
    #-------------------------------------------------------------------------------------------

    def OnGetItemText(self, item, col):
        data = self.datasource[item]
        if col == 2:
            return format3P(data[col])
        else:
            return data[col]
    #-------------------------------------------------------------------------------------------
    
    def OnItemGetAttr(self, item):
        return None
    #-------------------------------------------------------------------------------------------
    
    def SetColumnCount(self, columncount):
        self._columnsortflag = [0] * columncount
        self._column = -1
        for col in range(columncount):
            self.ClearColumnImage(col)
    #-------------------------------------------------------------------------------------------

    def GetSortDirection(self, col):
        if col < len(self._columnsortflag):
            return self._columnsortflag[col]
        else:
            return -1
    #-------------------------------------------------------------------------------------------

    def GetSortImages(self):
        return (self.sm_dn, self.sm_up)
    #-------------------------------------------------------------------------------------------

    def UpdateImages(self, column, direction):
        oldcolumn = self._column
        if column != -1:
            self._column = column
            self._columnsortflag[column] = direction
        
            sortimages = self.GetSortImages()
            if self._column != -1 and sortimages[0] != -1:
                imgindex = sortimages[self._columnsortflag[self._column]]
                if oldcolumn != -1:
                    self.ClearColumnImage(oldcolumn)
                self.SetColumnImage(self._column, imgindex)
    #-------------------------------------------------------------------------------------------

    def OnGetItemImage(self, item):
        return self.fileidx
    #-------------------------------------------------------------------------------------------
    
    def setDataSource(self, datasource, itemcount):
        self.DeleteAllItems()
        self.datasource = datasource
        self.SetItemCount(itemcount)        
# - class VirtualListCtrl(wx.ListCtrl):--------------------------------------------------------
